define("io.ox/backbone/mini-views/alarms",["io.ox/calendar/util","io.ox/backbone/views/disposable","gettext!io.ox/calendar","settings!io.ox/calendar","less!io.ox/backbone/mini-views/alarms"],function(n,e,s,t){"use strict";var i=t.get("availableAlarmTypes",["DISPLAY","AUDIO","EMAIL"]),o={DISPLAY:s("Notification"),AUDIO:s("Audio"),EMAIL:s("Mail"),"X-SMS":s("SMS")},l={"START-":s("before start"),START:s("after start"),"END-":s("before end"),END:s("after end")},r={"DISPLAYSTART-":s("Notify %1$s before start."),DISPLAYSTART:s("Notify %1$s after start."),"DISPLAYEND-":s("Notify %1$s before end."),DISPLAYEND:s("Notify %1$s after end."),DISPLAYABS:s("Notify at %1$s."),DISPLAYSTART0:s("Notify at start."),DISPLAYEND0:s("Notify at end."),"AUDIOSTART-":s("Play sound %1$s before start."),AUDIOSTART:s("Play sound %1$s after start."),"AUDIOEND-":s("Play sound %1$s before end."),AUDIOEND:s("Play sound %1$s after end."),AUDIOABS:s("Play sound at %1$s."),AUDIOSTART0:s("Play sound at start."),AUDIOEND0:s("Play sound at end."),"EMAILSTART-":s("Send mail %1$s before start."),EMAILSTART:s("Send mail %1$s after start."),"EMAILEND-":s("Send mail %1$s before end."),EMAILEND:s("Send mail %1$s after end."),EMAILABS:s("Send mail at %1$s."),EMAILSTART0:s("Send mail at start."),EMAILEND0:s("Send mail at end."),"SMSSTART-":s("Send SMS %1$s before start."),SMSSTART:s("Send SMS %1$s after start."),"SMSEND-":s("Send SMS %1$s before end."),SMSEND:s("Send SMS %1$s after end."),SMSABS:s("Send SMS at %1$s."),SMSSTART0:s("Send SMS at start."),SMSEND0:s("Send SMS at end."),"GENERICSTART-":s("%1$s %2$s before start."),GENERICSTART:s("%1$s %2$s after start."),"GENERICEND-":s("%1$s %2$s before end."),GENERICEND:s("%1$s %2$s after end."),GENERICABS:s("%1$s at %2$s."),GENERICSTART0:s("%1$s at start."),GENERICEND0:s("%1$s at end.")},d=e.extend({className:"alarms-view",events:{"click .alarm-remove":"onRemove","change .alarm-action":"updateModel","change .alarm-time":"updateModel","change .alarm-related":"updateModel"},initialize:function(e){this.options=e||{},this.attribute=e.attribute||"alarms",this.phoneNumber=e.phoneNumber,this.supportedTypes=e.phoneNumber?i:_(i).without("X-SMS"),this.list=$('<div class="alarm-list">'),this.model&&this.listenTo(this.model,"change:"+this.attribute,this.updateView)},render:function(){var a=this;return this.$el.empty().append(a.list,$('<button class="btn btn-default" type="button">').text(s("Add reminder")).on("click",function(){var e="alarms"===a.attribute&&a.model?n.isAllday(a.model)?"-PT12H":"-PT15M":"chronos/defaultAlarmDate"===a.attribute||"birthdays/defaultAlarmDate"===a.attribute?"-PT12H":"-PT15M",t=-1===_(i).indexOf("DISPLAY")&&i[0]||"DISPLAY",e=a.createNodeFromAlarm({action:t,trigger:{duration:e,related:"START"}});a.list.append(e),e.find(".alarm-action").focus(),a.updateModel()})),this.updateView(),this},onRemove:function(e){e.stopPropagation(),$(e.target).closest(".alarm-list-item").remove(),this.updateModel()},updateModel:function(){this.model&&(this.changedByUser=!0,this.model.set(this.attribute,this.getAlarmsArray()),this.changedByUser=!1)},updateView:function(){this.changedByUser||this.list.empty().append(this.model?_(this.model.get(this.attribute)).map(this.createNodeFromAlarm.bind(this)):[])},createNodeFromAlarm:function(e,t){if(t=(t||this.list.children().length)+1,e&&e.trigger){var a,i=_.uniqueId(),r=$('<fieldset class="alarm-list-item">').data("id",e.uid).append($('<legend class="sr-only">').text(s("Reminder %1$d",t)),a=$('<div class="item">'));return 1===this.supportedTypes.length||-1===_(this.supportedTypes).indexOf(e.action)?a.append($('<div class="alarm-action" tabindex="0">').text(o[e.action]||e.action).val(e.action)):a.append($('<label class="sr-only">').attr("for","action-"+i).text(s("type")),$('<select class="form-control alarm-action">').attr("id","action-"+i).append(_(this.supportedTypes).map(function(e){return $("<option>").text(o[e]||e).val(e)})).val(e.action)),e.trigger.duration?(a.append($('<label class="sr-only">').attr("for","time-"+i).text(s("timeframe")),t=$('<select class="form-control alarm-time">').attr("id","time-"+i).append(_.map(n.getReminderOptions(),function(e,t){return'<option value="'+t+'">'+e+"</option>"})),$('<label class="sr-only">').attr("for","related-"+i).text(s("timeframe relation")),i=$('<select class="form-control alarm-related">').attr("id","related-"+i).append(_.map(l,function(e,t){return'<option value="'+t+'">'+e+"</option>"}))),-1===_(_(n.getReminderOptions()).keys()).indexOf(e.trigger.duration.replace("-",""))&&(/^[-+]?PT0[SHDW]$/.test(e.trigger.duration)?t.find('[value="PT0M"]').val(e.trigger.duration.replace("-","")):t.append($("<option>").val(e.trigger.duration.replace("-","")).text(new moment.duration(e.trigger.duration).humanize()))),i.val((e.trigger.related||"START")+e.trigger.duration.replace(/\w*/g,"")),t.val(e.trigger.duration.replace("-",""))):a.append($('<div class="alarm-time" tabindex="0">').text(new moment(e.trigger.dateTime).format("LLL")).val(e.trigger.dateTime)),a.append($('<button type="button" class="btn btn-link alarm-remove">').attr("aria-label",s("Remove reminder")).append($('<i class="fa fa-trash">'))),r}},getAlarmsArray:function(){var r=this;return _(this.list.children()).map(function(e){var t={action:$(e).find(".alarm-action").val()},a=$(e).find(".alarm-time").val(),i=$(e).find(".alarm-related").val();switch(0===a.indexOf("-P")||0===a.indexOf("P")?t.trigger={duration:i.replace(/\w*/g,"")+a,related:i.replace(/\W*/g,"")}:t.trigger={dateTime:a},(t=$(e).data("id")?_.extend(_(r.model.get("alarms")).findWhere({uid:$(e).data("id")}),t):t).action){case"DISPLAY":t.description||(t.description=r.model&&r.model.get("summary")||"reminder");break;case"X-SMS":t.description||(t.description=r.model&&r.model.get("summary")||"reminder"),!t.attendees&&r.phoneNumber&&(t.attendees=[{uri:"tel:"+r.phoneNumber}])}return t})}});return{linkView:e.extend({className:"alarms-link-view",events:{"click .alarm-link":"openDialog"},initialize:function(e){this.options=e||{},this.attribute=e.attribute||"alarms",this.model&&this.listenTo(this.model,"change:"+this.attribute,this.render)},render:function(){return this.$el.empty().append(0===(this.model.get(this.attribute)||[]).length?$('<button type="button" class="alarm-link btn btn-link">').text(s("No reminder")):this.drawList()),this},drawList:function(){var i=$('<ul class="list-unstyled alarm-link-list">');return _(this.model.get(this.attribute)).each(function(e){var t,a;e&&e.trigger&&(t=[],a=e.trigger.duration?(t.push(n.getReminderOptions()[e.trigger.duration.replace("-","")]||new moment.duration(e.trigger.duration).humanize()),(e.trigger.related||"START")+(-1===e.trigger.duration.indexOf("PT0")?e.trigger.duration.replace(/\w*/g,""):"0")):(t.push(new moment(e.trigger.dateTime).format("LLL")),"ABS"),t.push(e.action),a=r[e.action+a]||r["GENERIC"+a],i.append($("<li>").append($('<button type="button" class="alarm-link btn btn-link">').text(_.noI18n.format(a,t)))))}),i},openDialog:function(t){t=t||{};var r=this;require(["io.ox/backbone/views/modal","io.ox/core/api/user"],function(i,e){e.get({id:t.userId}).always(function(e){var t,a={},e=(e=e||{}).cellular_telephone1||e.cellular_telephone2;a[r.attribute]=_.deepClone(r.model.get(r.attribute)),t=new d({model:new Backbone.Model(a),attribute:r.attribute,phoneNumber:e}),new i({title:s("Edit reminders")}).build(function(){this.$body.append(t.render().$el),this.$el.addClass("alarms-view-dialog")}).addCancelButton().addButton({action:"apply",label:s("Apply")}).on("apply",function(){r.model.trigger("userChangedAlarms"),r.model.set(r.attribute,t.getAlarmsArray()).trigger("change:"+r.attribute),r.trigger("changed",r.model.get(r.attribute))}).open()})})}}),alarmsView:d}});